/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Instantbird messenging client, released
 * 2009.
 *
 * The Initial Developer of the Original Code is
 * Florian QUEZE <florian@instantbird.org>.
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

#include "purpleNetwork.h"
#include <nsCOMPtr.h>
#include <nsNetCID.h>
#include <nsServiceManagerUtils.h>
#include <nsIObserverService.h>
#include <nsINetworkLinkService.h>

#include <glib.h>
#pragma GCC visibility push(default)
#include <libpurple/network.h>
#pragma GCC visibility pop

purpleNetworkObserver *purpleNetworkObserver::mInstance = nsnull;

NS_IMPL_ISUPPORTS1(purpleNetworkObserver, nsIObserver)

purpleNetworkObserver::purpleNetworkObserver()
{
  purple_network_set_available_callback(purpleNetworkObserver::IsNetworkAvailable);

  nsCOMPtr<nsIObserverService> observerService =
    do_GetService("@mozilla.org/observer-service;1");
  observerService->AddObserver(this, NS_NETWORK_LINK_TOPIC, PR_FALSE);
}

purpleNetworkObserver::~purpleNetworkObserver()
{
  purple_network_set_available_callback(NULL);
}

void
purpleNetworkObserver::init()
{
  if (!mInstance)
    mInstance = new purpleNetworkObserver();
}

void 
purpleNetworkObserver::unInit()
{
  if (!mInstance)
    return;

  nsCOMPtr<nsIObserverService> observerService =
    do_GetService("@mozilla.org/observer-service;1");
  observerService->RemoveObserver(mInstance, NS_NETWORK_LINK_TOPIC);

  mInstance = nsnull;
}

PRBool
purpleNetworkObserver::IsNetworkAvailable()
{
  nsCOMPtr<nsINetworkLinkService> networkLinkService =
    do_GetService(NS_NETWORK_LINK_SERVICE_CONTRACTID);

  PRBool isUp;
  nsresult rv = networkLinkService->GetIsLinkUp(&isUp);
  NS_ENSURE_SUCCESS(rv, PR_TRUE);
  return isUp;
}

NS_IMETHODIMP
purpleNetworkObserver::Observe(nsISupports *aSubject,
                               const char *aTopic,
                               const PRUnichar *aData)
{
  purple_network_configuration_changed();

  return NS_OK;
}
